/* rygel-mpris-interfaces.c generated by valac 0.44.9, the Vala compiler
 * generated from rygel-mpris-interfaces.vala, do not modify */

/*
 * Copyright (C) 2009,2010 Nokia Corporation.
 *
 * Author: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *                               <zeeshan.ali@nokia.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#define RYGEL_MPRIS_TYPE_MEDIA_PLAYER_PROXY (rygel_mpris_media_player_proxy_get_type ())
#define RYGEL_MPRIS_MEDIA_PLAYER_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MPRIS_TYPE_MEDIA_PLAYER_PROXY, RygelMPRISMediaPlayerProxy))
#define RYGEL_MPRIS_IS_MEDIA_PLAYER_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MPRIS_TYPE_MEDIA_PLAYER_PROXY))
#define RYGEL_MPRIS_MEDIA_PLAYER_PROXY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), RYGEL_MPRIS_TYPE_MEDIA_PLAYER_PROXY, RygelMPRISMediaPlayerProxyIface))

typedef struct _RygelMPRISMediaPlayerProxy RygelMPRISMediaPlayerProxy;
typedef struct _RygelMPRISMediaPlayerProxyIface RygelMPRISMediaPlayerProxyIface;

#define RYGEL_MPRIS_TYPE_MEDIA_PLAYER_PROXY_PROXY (rygel_mpris_media_player_proxy_proxy_get_type ())
typedef GDBusProxy RygelMPRISMediaPlayerProxyProxy;
typedef GDBusProxyClass RygelMPRISMediaPlayerProxyProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define RYGEL_MPRIS_MEDIA_PLAYER_TYPE_PLAYER_PROXY (rygel_mpris_media_player_player_proxy_get_type ())
#define RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MPRIS_MEDIA_PLAYER_TYPE_PLAYER_PROXY, RygelMPRISMediaPlayerPlayerProxy))
#define RYGEL_MPRIS_MEDIA_PLAYER_IS_PLAYER_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MPRIS_MEDIA_PLAYER_TYPE_PLAYER_PROXY))
#define RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), RYGEL_MPRIS_MEDIA_PLAYER_TYPE_PLAYER_PROXY, RygelMPRISMediaPlayerPlayerProxyIface))

typedef struct _RygelMPRISMediaPlayerPlayerProxy RygelMPRISMediaPlayerPlayerProxy;
typedef struct _RygelMPRISMediaPlayerPlayerProxyIface RygelMPRISMediaPlayerPlayerProxyIface;

#define RYGEL_MPRIS_MEDIA_PLAYER_TYPE_PLAYER_PROXY_PROXY (rygel_mpris_media_player_player_proxy_proxy_get_type ())
typedef GDBusProxy RygelMPRISMediaPlayerPlayerProxyProxy;
typedef GDBusProxyClass RygelMPRISMediaPlayerPlayerProxyProxyClass;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

struct _RygelMPRISMediaPlayerProxyIface {
	GTypeInterface parent_iface;
	gchar* (*get_identity) (RygelMPRISMediaPlayerProxy* self);
	gchar** (*get_supported_uri_schemes) (RygelMPRISMediaPlayerProxy* self, gint* result_length1);
	gchar** (*get_supported_mime_types) (RygelMPRISMediaPlayerProxy* self, gint* result_length1);
};

struct _RygelMPRISMediaPlayerPlayerProxyIface {
	GTypeInterface parent_iface;
	void (*pause) (RygelMPRISMediaPlayerPlayerProxy* self, GError** error);
	void (*play_pause) (RygelMPRISMediaPlayerPlayerProxy* self, GError** error);
	void (*stop) (RygelMPRISMediaPlayerPlayerProxy* self, GError** error);
	void (*play) (RygelMPRISMediaPlayerPlayerProxy* self, GError** error);
	void (*seek) (RygelMPRISMediaPlayerPlayerProxy* self, gint64 offset, GError** error);
	void (*open_uri) (RygelMPRISMediaPlayerPlayerProxy* self, const gchar* uri, GError** error);
	gchar* (*get_playback_status) (RygelMPRISMediaPlayerPlayerProxy* self);
	gdouble (*get_rate) (RygelMPRISMediaPlayerPlayerProxy* self);
	void (*set_rate) (RygelMPRISMediaPlayerPlayerProxy* self, gdouble value);
	gdouble (*get_minimum_rate) (RygelMPRISMediaPlayerPlayerProxy* self);
	gdouble (*get_maximum_rate) (RygelMPRISMediaPlayerPlayerProxy* self);
	gdouble (*get_volume) (RygelMPRISMediaPlayerPlayerProxy* self);
	void (*set_volume) (RygelMPRISMediaPlayerPlayerProxy* self, gdouble value);
	gint64 (*get_position) (RygelMPRISMediaPlayerPlayerProxy* self);
	gboolean (*get_can_seek) (RygelMPRISMediaPlayerPlayerProxy* self);
	gboolean (*get_can_control) (RygelMPRISMediaPlayerPlayerProxy* self);
	GHashTable* (*get_metadata) (RygelMPRISMediaPlayerPlayerProxy* self);
};

GType rygel_mpris_media_player_proxy_get_type (void) G_GNUC_CONST;
GType rygel_mpris_media_player_proxy_proxy_get_type (void) G_GNUC_CONST;
guint rygel_mpris_media_player_proxy_register_object (void* object,
                                                      GDBusConnection* connection,
                                                      const gchar* path,
                                                      GError** error);
#define RYGEL_MPRIS_MEDIA_PLAYER_PROXY_IFACE "org.mpris.MediaPlayer2"
gchar* rygel_mpris_media_player_proxy_get_identity (RygelMPRISMediaPlayerProxy* self);
gchar** rygel_mpris_media_player_proxy_get_supported_uri_schemes (RygelMPRISMediaPlayerProxy* self,
                                                                  gint* result_length1);
gchar** rygel_mpris_media_player_proxy_get_supported_mime_types (RygelMPRISMediaPlayerProxy* self,
                                                                 gint* result_length1);
static void rygel_mpris_media_player_proxy_proxy_g_signal (GDBusProxy* proxy,
                                                    const gchar* sender_name,
                                                    const gchar* signal_name,
                                                    GVariant* parameters);
static gchar* rygel_mpris_media_player_proxy_dbus_proxy_get_identity (RygelMPRISMediaPlayerProxy* self);
static gchar** rygel_mpris_media_player_proxy_dbus_proxy_get_supported_uri_schemes (RygelMPRISMediaPlayerProxy* self,
                                                                             gint* result_length1);
static gchar** rygel_mpris_media_player_proxy_dbus_proxy_get_supported_mime_types (RygelMPRISMediaPlayerProxy* self,
                                                                            gint* result_length1);
static void rygel_mpris_media_player_proxy_proxy_rygel_mpris_media_player_proxy_interface_init (RygelMPRISMediaPlayerProxyIface* iface);
static void rygel_mpris_media_player_proxy_dbus_interface_method_call (GDBusConnection* connection,
                                                                const gchar* sender,
                                                                const gchar* object_path,
                                                                const gchar* interface_name,
                                                                const gchar* method_name,
                                                                GVariant* parameters,
                                                                GDBusMethodInvocation* invocation,
                                                                gpointer user_data);
static GVariant* rygel_mpris_media_player_proxy_dbus_interface_get_property (GDBusConnection* connection,
                                                                      const gchar* sender,
                                                                      const gchar* object_path,
                                                                      const gchar* interface_name,
                                                                      const gchar* property_name,
                                                                      GError** error,
                                                                      gpointer user_data);
static GVariant* _dbus_rygel_mpris_media_player_proxy_get_identity (RygelMPRISMediaPlayerProxy* self);
static GVariant* _dbus_rygel_mpris_media_player_proxy_get_supported_uri_schemes (RygelMPRISMediaPlayerProxy* self);
static GVariant* _dbus_rygel_mpris_media_player_proxy_get_supported_mime_types (RygelMPRISMediaPlayerProxy* self);
static gboolean rygel_mpris_media_player_proxy_dbus_interface_set_property (GDBusConnection* connection,
                                                                     const gchar* sender,
                                                                     const gchar* object_path,
                                                                     const gchar* interface_name,
                                                                     const gchar* property_name,
                                                                     GVariant* value,
                                                                     GError** error,
                                                                     gpointer user_data);
static void _rygel_mpris_media_player_proxy_unregister_object (gpointer user_data);
GType rygel_mpris_media_player_player_proxy_proxy_get_type (void) G_GNUC_CONST;
guint rygel_mpris_media_player_player_proxy_register_object (void* object,
                                                             GDBusConnection* connection,
                                                             const gchar* path,
                                                             GError** error);
GType rygel_mpris_media_player_player_proxy_get_type (void) G_GNUC_CONST;
void rygel_mpris_media_player_player_proxy_pause (RygelMPRISMediaPlayerPlayerProxy* self,
                                                  GError** error);
void rygel_mpris_media_player_player_proxy_play_pause (RygelMPRISMediaPlayerPlayerProxy* self,
                                                       GError** error);
void rygel_mpris_media_player_player_proxy_stop (RygelMPRISMediaPlayerPlayerProxy* self,
                                                 GError** error);
void rygel_mpris_media_player_player_proxy_play (RygelMPRISMediaPlayerPlayerProxy* self,
                                                 GError** error);
void rygel_mpris_media_player_player_proxy_seek (RygelMPRISMediaPlayerPlayerProxy* self,
                                                 gint64 offset,
                                                 GError** error);
void rygel_mpris_media_player_player_proxy_open_uri (RygelMPRISMediaPlayerPlayerProxy* self,
                                                     const gchar* uri,
                                                     GError** error);
#define RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_IFACE "org.mpris.MediaPlayer2.Player"
gchar* rygel_mpris_media_player_player_proxy_get_playback_status (RygelMPRISMediaPlayerPlayerProxy* self);
gdouble rygel_mpris_media_player_player_proxy_get_rate (RygelMPRISMediaPlayerPlayerProxy* self);
void rygel_mpris_media_player_player_proxy_set_rate (RygelMPRISMediaPlayerPlayerProxy* self,
                                                     gdouble value);
gdouble rygel_mpris_media_player_player_proxy_get_minimum_rate (RygelMPRISMediaPlayerPlayerProxy* self);
gdouble rygel_mpris_media_player_player_proxy_get_maximum_rate (RygelMPRISMediaPlayerPlayerProxy* self);
gdouble rygel_mpris_media_player_player_proxy_get_volume (RygelMPRISMediaPlayerPlayerProxy* self);
void rygel_mpris_media_player_player_proxy_set_volume (RygelMPRISMediaPlayerPlayerProxy* self,
                                                       gdouble value);
gint64 rygel_mpris_media_player_player_proxy_get_position (RygelMPRISMediaPlayerPlayerProxy* self);
gboolean rygel_mpris_media_player_player_proxy_get_can_seek (RygelMPRISMediaPlayerPlayerProxy* self);
gboolean rygel_mpris_media_player_player_proxy_get_can_control (RygelMPRISMediaPlayerPlayerProxy* self);
GHashTable* rygel_mpris_media_player_player_proxy_get_metadata (RygelMPRISMediaPlayerPlayerProxy* self);
static void rygel_mpris_media_player_player_proxy_proxy_g_signal (GDBusProxy* proxy,
                                                           const gchar* sender_name,
                                                           const gchar* signal_name,
                                                           GVariant* parameters);
static gchar* rygel_mpris_media_player_player_proxy_dbus_proxy_get_identity (RygelMPRISMediaPlayerProxy* self);
static gchar** rygel_mpris_media_player_player_proxy_dbus_proxy_get_supported_uri_schemes (RygelMPRISMediaPlayerProxy* self,
                                                                                    gint* result_length1);
static gchar** rygel_mpris_media_player_player_proxy_dbus_proxy_get_supported_mime_types (RygelMPRISMediaPlayerProxy* self,
                                                                                   gint* result_length1);
static void rygel_mpris_media_player_player_proxy_proxy_rygel_mpris_media_player_proxy_interface_init (RygelMPRISMediaPlayerProxyIface* iface);
static void rygel_mpris_media_player_player_proxy_proxy_pause (RygelMPRISMediaPlayerPlayerProxy* self,
                                                        GError** error);
static void rygel_mpris_media_player_player_proxy_proxy_play_pause (RygelMPRISMediaPlayerPlayerProxy* self,
                                                             GError** error);
static void rygel_mpris_media_player_player_proxy_proxy_stop (RygelMPRISMediaPlayerPlayerProxy* self,
                                                       GError** error);
static void rygel_mpris_media_player_player_proxy_proxy_play (RygelMPRISMediaPlayerPlayerProxy* self,
                                                       GError** error);
static void rygel_mpris_media_player_player_proxy_proxy_seek (RygelMPRISMediaPlayerPlayerProxy* self,
                                                       gint64 offset,
                                                       GError** error);
static void rygel_mpris_media_player_player_proxy_proxy_open_uri (RygelMPRISMediaPlayerPlayerProxy* self,
                                                           const gchar* uri,
                                                           GError** error);
static gchar* rygel_mpris_media_player_player_proxy_dbus_proxy_get_playback_status (RygelMPRISMediaPlayerPlayerProxy* self);
static gdouble rygel_mpris_media_player_player_proxy_dbus_proxy_get_rate (RygelMPRISMediaPlayerPlayerProxy* self);
static void rygel_mpris_media_player_player_proxy_dbus_proxy_set_rate (RygelMPRISMediaPlayerPlayerProxy* self,
                                                                gdouble value);
static gdouble rygel_mpris_media_player_player_proxy_dbus_proxy_get_minimum_rate (RygelMPRISMediaPlayerPlayerProxy* self);
static gdouble rygel_mpris_media_player_player_proxy_dbus_proxy_get_maximum_rate (RygelMPRISMediaPlayerPlayerProxy* self);
static gdouble rygel_mpris_media_player_player_proxy_dbus_proxy_get_volume (RygelMPRISMediaPlayerPlayerProxy* self);
static void rygel_mpris_media_player_player_proxy_dbus_proxy_set_volume (RygelMPRISMediaPlayerPlayerProxy* self,
                                                                  gdouble value);
static gint64 rygel_mpris_media_player_player_proxy_dbus_proxy_get_position (RygelMPRISMediaPlayerPlayerProxy* self);
static gboolean rygel_mpris_media_player_player_proxy_dbus_proxy_get_can_seek (RygelMPRISMediaPlayerPlayerProxy* self);
static gboolean rygel_mpris_media_player_player_proxy_dbus_proxy_get_can_control (RygelMPRISMediaPlayerPlayerProxy* self);
static GHashTable* rygel_mpris_media_player_player_proxy_dbus_proxy_get_metadata (RygelMPRISMediaPlayerPlayerProxy* self);
static void rygel_mpris_media_player_player_proxy_proxy_rygel_mpris_media_player_player_proxy_interface_init (RygelMPRISMediaPlayerPlayerProxyIface* iface);
static void _dbus_rygel_mpris_media_player_player_proxy_pause (RygelMPRISMediaPlayerPlayerProxy* self,
                                                        GVariant* _parameters_,
                                                        GDBusMethodInvocation* invocation);
static void _dbus_rygel_mpris_media_player_player_proxy_play_pause (RygelMPRISMediaPlayerPlayerProxy* self,
                                                             GVariant* _parameters_,
                                                             GDBusMethodInvocation* invocation);
static void _dbus_rygel_mpris_media_player_player_proxy_stop (RygelMPRISMediaPlayerPlayerProxy* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void _dbus_rygel_mpris_media_player_player_proxy_play (RygelMPRISMediaPlayerPlayerProxy* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void _dbus_rygel_mpris_media_player_player_proxy_seek (RygelMPRISMediaPlayerPlayerProxy* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void _dbus_rygel_mpris_media_player_player_proxy_open_uri (RygelMPRISMediaPlayerPlayerProxy* self,
                                                           GVariant* _parameters_,
                                                           GDBusMethodInvocation* invocation);
static void rygel_mpris_media_player_player_proxy_dbus_interface_method_call (GDBusConnection* connection,
                                                                       const gchar* sender,
                                                                       const gchar* object_path,
                                                                       const gchar* interface_name,
                                                                       const gchar* method_name,
                                                                       GVariant* parameters,
                                                                       GDBusMethodInvocation* invocation,
                                                                       gpointer user_data);
static GVariant* rygel_mpris_media_player_player_proxy_dbus_interface_get_property (GDBusConnection* connection,
                                                                             const gchar* sender,
                                                                             const gchar* object_path,
                                                                             const gchar* interface_name,
                                                                             const gchar* property_name,
                                                                             GError** error,
                                                                             gpointer user_data);
static GVariant* _dbus_rygel_mpris_media_player_player_proxy_get_playback_status (RygelMPRISMediaPlayerPlayerProxy* self);
static GVariant* _dbus_rygel_mpris_media_player_player_proxy_get_rate (RygelMPRISMediaPlayerPlayerProxy* self);
static GVariant* _dbus_rygel_mpris_media_player_player_proxy_get_minimum_rate (RygelMPRISMediaPlayerPlayerProxy* self);
static GVariant* _dbus_rygel_mpris_media_player_player_proxy_get_maximum_rate (RygelMPRISMediaPlayerPlayerProxy* self);
static GVariant* _dbus_rygel_mpris_media_player_player_proxy_get_volume (RygelMPRISMediaPlayerPlayerProxy* self);
static GVariant* _dbus_rygel_mpris_media_player_player_proxy_get_position (RygelMPRISMediaPlayerPlayerProxy* self);
static GVariant* _dbus_rygel_mpris_media_player_player_proxy_get_can_seek (RygelMPRISMediaPlayerPlayerProxy* self);
static GVariant* _dbus_rygel_mpris_media_player_player_proxy_get_can_control (RygelMPRISMediaPlayerPlayerProxy* self);
static GVariant* _dbus_rygel_mpris_media_player_player_proxy_get_metadata (RygelMPRISMediaPlayerPlayerProxy* self);
static gboolean rygel_mpris_media_player_player_proxy_dbus_interface_set_property (GDBusConnection* connection,
                                                                            const gchar* sender,
                                                                            const gchar* object_path,
                                                                            const gchar* interface_name,
                                                                            const gchar* property_name,
                                                                            GVariant* value,
                                                                            GError** error,
                                                                            gpointer user_data);
static void _dbus_rygel_mpris_media_player_player_proxy_set_rate (RygelMPRISMediaPlayerPlayerProxy* self,
                                                           GVariant* _value);
static void _dbus_rygel_mpris_media_player_player_proxy_set_volume (RygelMPRISMediaPlayerPlayerProxy* self,
                                                             GVariant* _value);
static void _rygel_mpris_media_player_player_proxy_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const GDBusMethodInfo * const _rygel_mpris_media_player_proxy_dbus_method_info[] = {NULL};
static const GDBusSignalInfo * const _rygel_mpris_media_player_proxy_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _rygel_mpris_media_player_proxy_dbus_property_info_identity = {-1, "Identity", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _rygel_mpris_media_player_proxy_dbus_property_info_supported_uri_schemes = {-1, "SupportedUriSchemes", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _rygel_mpris_media_player_proxy_dbus_property_info_supported_mime_types = {-1, "SupportedMimeTypes", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _rygel_mpris_media_player_proxy_dbus_property_info[] = {&_rygel_mpris_media_player_proxy_dbus_property_info_identity, &_rygel_mpris_media_player_proxy_dbus_property_info_supported_uri_schemes, &_rygel_mpris_media_player_proxy_dbus_property_info_supported_mime_types, NULL};
static const GDBusInterfaceInfo _rygel_mpris_media_player_proxy_dbus_interface_info = {-1, "org.mpris.MediaPlayer2", (GDBusMethodInfo **) (&_rygel_mpris_media_player_proxy_dbus_method_info), (GDBusSignalInfo **) (&_rygel_mpris_media_player_proxy_dbus_signal_info), (GDBusPropertyInfo **) (&_rygel_mpris_media_player_proxy_dbus_property_info), NULL};
static const GDBusInterfaceVTable _rygel_mpris_media_player_proxy_dbus_interface_vtable = {rygel_mpris_media_player_proxy_dbus_interface_method_call, rygel_mpris_media_player_proxy_dbus_interface_get_property, rygel_mpris_media_player_proxy_dbus_interface_set_property};
static const GDBusArgInfo * const _rygel_mpris_media_player_player_proxy_dbus_arg_info_pause_in[] = {NULL};
static const GDBusArgInfo * const _rygel_mpris_media_player_player_proxy_dbus_arg_info_pause_out[] = {NULL};
static const GDBusMethodInfo _rygel_mpris_media_player_player_proxy_dbus_method_info_pause = {-1, "Pause", (GDBusArgInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_arg_info_pause_in), (GDBusArgInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_arg_info_pause_out), NULL};
static const GDBusArgInfo * const _rygel_mpris_media_player_player_proxy_dbus_arg_info_play_pause_in[] = {NULL};
static const GDBusArgInfo * const _rygel_mpris_media_player_player_proxy_dbus_arg_info_play_pause_out[] = {NULL};
static const GDBusMethodInfo _rygel_mpris_media_player_player_proxy_dbus_method_info_play_pause = {-1, "PlayPause", (GDBusArgInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_arg_info_play_pause_in), (GDBusArgInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_arg_info_play_pause_out), NULL};
static const GDBusArgInfo * const _rygel_mpris_media_player_player_proxy_dbus_arg_info_stop_in[] = {NULL};
static const GDBusArgInfo * const _rygel_mpris_media_player_player_proxy_dbus_arg_info_stop_out[] = {NULL};
static const GDBusMethodInfo _rygel_mpris_media_player_player_proxy_dbus_method_info_stop = {-1, "Stop", (GDBusArgInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_arg_info_stop_in), (GDBusArgInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_arg_info_stop_out), NULL};
static const GDBusArgInfo * const _rygel_mpris_media_player_player_proxy_dbus_arg_info_play_in[] = {NULL};
static const GDBusArgInfo * const _rygel_mpris_media_player_player_proxy_dbus_arg_info_play_out[] = {NULL};
static const GDBusMethodInfo _rygel_mpris_media_player_player_proxy_dbus_method_info_play = {-1, "Play", (GDBusArgInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_arg_info_play_in), (GDBusArgInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_arg_info_play_out), NULL};
static const GDBusArgInfo _rygel_mpris_media_player_player_proxy_dbus_arg_info_seek_offset = {-1, "offset", "x", NULL};
static const GDBusArgInfo * const _rygel_mpris_media_player_player_proxy_dbus_arg_info_seek_in[] = {&_rygel_mpris_media_player_player_proxy_dbus_arg_info_seek_offset, NULL};
static const GDBusArgInfo * const _rygel_mpris_media_player_player_proxy_dbus_arg_info_seek_out[] = {NULL};
static const GDBusMethodInfo _rygel_mpris_media_player_player_proxy_dbus_method_info_seek = {-1, "Seek", (GDBusArgInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_arg_info_seek_in), (GDBusArgInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_arg_info_seek_out), NULL};
static const GDBusArgInfo _rygel_mpris_media_player_player_proxy_dbus_arg_info_open_uri_uri = {-1, "uri", "s", NULL};
static const GDBusArgInfo * const _rygel_mpris_media_player_player_proxy_dbus_arg_info_open_uri_in[] = {&_rygel_mpris_media_player_player_proxy_dbus_arg_info_open_uri_uri, NULL};
static const GDBusArgInfo * const _rygel_mpris_media_player_player_proxy_dbus_arg_info_open_uri_out[] = {NULL};
static const GDBusMethodInfo _rygel_mpris_media_player_player_proxy_dbus_method_info_open_uri = {-1, "OpenUri", (GDBusArgInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_arg_info_open_uri_in), (GDBusArgInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_arg_info_open_uri_out), NULL};
static const GDBusMethodInfo * const _rygel_mpris_media_player_player_proxy_dbus_method_info[] = {&_rygel_mpris_media_player_player_proxy_dbus_method_info_pause, &_rygel_mpris_media_player_player_proxy_dbus_method_info_play_pause, &_rygel_mpris_media_player_player_proxy_dbus_method_info_stop, &_rygel_mpris_media_player_player_proxy_dbus_method_info_play, &_rygel_mpris_media_player_player_proxy_dbus_method_info_seek, &_rygel_mpris_media_player_player_proxy_dbus_method_info_open_uri, NULL};
static const GDBusSignalInfo * const _rygel_mpris_media_player_player_proxy_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _rygel_mpris_media_player_player_proxy_dbus_property_info_playback_status = {-1, "PlaybackStatus", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _rygel_mpris_media_player_player_proxy_dbus_property_info_rate = {-1, "Rate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _rygel_mpris_media_player_player_proxy_dbus_property_info_minimum_rate = {-1, "MinimumRate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _rygel_mpris_media_player_player_proxy_dbus_property_info_maximum_rate = {-1, "MaximumRate", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _rygel_mpris_media_player_player_proxy_dbus_property_info_volume = {-1, "Volume", "d", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _rygel_mpris_media_player_player_proxy_dbus_property_info_position = {-1, "Position", "x", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _rygel_mpris_media_player_player_proxy_dbus_property_info_can_seek = {-1, "CanSeek", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _rygel_mpris_media_player_player_proxy_dbus_property_info_can_control = {-1, "CanControl", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _rygel_mpris_media_player_player_proxy_dbus_property_info_metadata = {-1, "Metadata", "a{sv}", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _rygel_mpris_media_player_player_proxy_dbus_property_info[] = {&_rygel_mpris_media_player_player_proxy_dbus_property_info_playback_status, &_rygel_mpris_media_player_player_proxy_dbus_property_info_rate, &_rygel_mpris_media_player_player_proxy_dbus_property_info_minimum_rate, &_rygel_mpris_media_player_player_proxy_dbus_property_info_maximum_rate, &_rygel_mpris_media_player_player_proxy_dbus_property_info_volume, &_rygel_mpris_media_player_player_proxy_dbus_property_info_position, &_rygel_mpris_media_player_player_proxy_dbus_property_info_can_seek, &_rygel_mpris_media_player_player_proxy_dbus_property_info_can_control, &_rygel_mpris_media_player_player_proxy_dbus_property_info_metadata, NULL};
static const GDBusInterfaceInfo _rygel_mpris_media_player_player_proxy_dbus_interface_info = {-1, "org.mpris.MediaPlayer2.Player", (GDBusMethodInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_method_info), (GDBusSignalInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_signal_info), (GDBusPropertyInfo **) (&_rygel_mpris_media_player_player_proxy_dbus_property_info), NULL};
static const GDBusInterfaceVTable _rygel_mpris_media_player_player_proxy_dbus_interface_vtable = {rygel_mpris_media_player_player_proxy_dbus_interface_method_call, rygel_mpris_media_player_player_proxy_dbus_interface_get_property, rygel_mpris_media_player_player_proxy_dbus_interface_set_property};

gchar*
rygel_mpris_media_player_proxy_get_identity (RygelMPRISMediaPlayerProxy* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return RYGEL_MPRIS_MEDIA_PLAYER_PROXY_GET_INTERFACE (self)->get_identity (self);
}

gchar**
rygel_mpris_media_player_proxy_get_supported_uri_schemes (RygelMPRISMediaPlayerProxy* self,
                                                          gint* result_length1)
{
	g_return_val_if_fail (self != NULL, NULL);
	return RYGEL_MPRIS_MEDIA_PLAYER_PROXY_GET_INTERFACE (self)->get_supported_uri_schemes (self, result_length1);
}

gchar**
rygel_mpris_media_player_proxy_get_supported_mime_types (RygelMPRISMediaPlayerProxy* self,
                                                         gint* result_length1)
{
	g_return_val_if_fail (self != NULL, NULL);
	return RYGEL_MPRIS_MEDIA_PLAYER_PROXY_GET_INTERFACE (self)->get_supported_mime_types (self, result_length1);
}

static void
rygel_mpris_media_player_proxy_default_init (RygelMPRISMediaPlayerProxyIface * iface,
                                             gpointer iface_data)
{
}

GType
rygel_mpris_media_player_proxy_get_type (void)
{
	static volatile gsize rygel_mpris_media_player_proxy_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_mpris_media_player_proxy_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelMPRISMediaPlayerProxyIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_mpris_media_player_proxy_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType rygel_mpris_media_player_proxy_type_id;
		rygel_mpris_media_player_proxy_type_id = g_type_register_static (G_TYPE_INTERFACE, "RygelMPRISMediaPlayerProxy", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (rygel_mpris_media_player_proxy_type_id, g_dbus_proxy_get_type ());
		g_type_set_qdata (rygel_mpris_media_player_proxy_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) rygel_mpris_media_player_proxy_proxy_get_type);
		g_type_set_qdata (rygel_mpris_media_player_proxy_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.mpris.MediaPlayer2");
		g_type_set_qdata (rygel_mpris_media_player_proxy_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_rygel_mpris_media_player_proxy_dbus_interface_info));
		g_type_set_qdata (rygel_mpris_media_player_proxy_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) rygel_mpris_media_player_proxy_register_object);
		g_once_init_leave (&rygel_mpris_media_player_proxy_type_id__volatile, rygel_mpris_media_player_proxy_type_id);
	}
	return rygel_mpris_media_player_proxy_type_id__volatile;
}

G_DEFINE_TYPE_EXTENDED (RygelMPRISMediaPlayerProxyProxy, rygel_mpris_media_player_proxy_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (RYGEL_MPRIS_TYPE_MEDIA_PLAYER_PROXY, rygel_mpris_media_player_proxy_proxy_rygel_mpris_media_player_proxy_interface_init) )
static void
rygel_mpris_media_player_proxy_proxy_class_init (RygelMPRISMediaPlayerProxyProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = rygel_mpris_media_player_proxy_proxy_g_signal;
}

static void
rygel_mpris_media_player_proxy_proxy_g_signal (GDBusProxy* proxy,
                                               const gchar* sender_name,
                                               const gchar* signal_name,
                                               GVariant* parameters)
{
}

static void
rygel_mpris_media_player_proxy_proxy_init (RygelMPRISMediaPlayerProxyProxy* self)
{
}

static gchar*
rygel_mpris_media_player_proxy_dbus_proxy_get_identity (RygelMPRISMediaPlayerProxy* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Identity");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Identity"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}

static gchar**
rygel_mpris_media_player_proxy_dbus_proxy_get_supported_uri_schemes (RygelMPRISMediaPlayerProxy* self,
                                                                     gint* result_length1)
{
	GVariant *_inner_reply;
	gchar** _result;
	gint _result_length1;
	gchar** _tmp0_;
	gint _tmp0__length;
	gint _tmp0__size;
	gint _tmp0__length1;
	GVariantIter _tmp1_;
	GVariant* _tmp2_;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "SupportedUriSchemes");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("SupportedUriSchemes"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result_length1 = 0;
	_tmp0_ = g_new (gchar*, 5);
	_tmp0__length = 0;
	_tmp0__size = 4;
	_tmp0__length1 = 0;
	g_variant_iter_init (&_tmp1_, _inner_reply);
	for (; (_tmp2_ = g_variant_iter_next_value (&_tmp1_)) != NULL; _tmp0__length1++) {
		if (_tmp0__size == _tmp0__length) {
			_tmp0__size = 2 * _tmp0__size;
			_tmp0_ = g_renew (gchar*, _tmp0_, _tmp0__size + 1);
		}
		_tmp0_[_tmp0__length++] = g_variant_dup_string (_tmp2_, NULL);
		g_variant_unref (_tmp2_);
	}
	_result_length1 = _tmp0__length1;
	_tmp0_[_tmp0__length] = NULL;
	_result = _tmp0_;
	*result_length1 = _result_length1;
	g_variant_unref (_inner_reply);
	return _result;
}

static gchar**
rygel_mpris_media_player_proxy_dbus_proxy_get_supported_mime_types (RygelMPRISMediaPlayerProxy* self,
                                                                    gint* result_length1)
{
	GVariant *_inner_reply;
	gchar** _result;
	gint _result_length1;
	gchar** _tmp3_;
	gint _tmp3__length;
	gint _tmp3__size;
	gint _tmp3__length1;
	GVariantIter _tmp4_;
	GVariant* _tmp5_;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "SupportedMimeTypes");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("SupportedMimeTypes"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result_length1 = 0;
	_tmp3_ = g_new (gchar*, 5);
	_tmp3__length = 0;
	_tmp3__size = 4;
	_tmp3__length1 = 0;
	g_variant_iter_init (&_tmp4_, _inner_reply);
	for (; (_tmp5_ = g_variant_iter_next_value (&_tmp4_)) != NULL; _tmp3__length1++) {
		if (_tmp3__size == _tmp3__length) {
			_tmp3__size = 2 * _tmp3__size;
			_tmp3_ = g_renew (gchar*, _tmp3_, _tmp3__size + 1);
		}
		_tmp3_[_tmp3__length++] = g_variant_dup_string (_tmp5_, NULL);
		g_variant_unref (_tmp5_);
	}
	_result_length1 = _tmp3__length1;
	_tmp3_[_tmp3__length] = NULL;
	_result = _tmp3_;
	*result_length1 = _result_length1;
	g_variant_unref (_inner_reply);
	return _result;
}

static void
rygel_mpris_media_player_proxy_proxy_rygel_mpris_media_player_proxy_interface_init (RygelMPRISMediaPlayerProxyIface* iface)
{
	iface->get_identity = rygel_mpris_media_player_proxy_dbus_proxy_get_identity;
	iface->get_supported_uri_schemes = rygel_mpris_media_player_proxy_dbus_proxy_get_supported_uri_schemes;
	iface->get_supported_mime_types = rygel_mpris_media_player_proxy_dbus_proxy_get_supported_mime_types;
}

static void
rygel_mpris_media_player_proxy_dbus_interface_method_call (GDBusConnection* connection,
                                                           const gchar* sender,
                                                           const gchar* object_path,
                                                           const gchar* interface_name,
                                                           const gchar* method_name,
                                                           GVariant* parameters,
                                                           GDBusMethodInvocation* invocation,
                                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}

static GVariant*
_dbus_rygel_mpris_media_player_proxy_get_identity (RygelMPRISMediaPlayerProxy* self)
{
	gchar* result;
	GVariant* _reply;
	result = rygel_mpris_media_player_proxy_get_identity (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
_dbus_rygel_mpris_media_player_proxy_get_supported_uri_schemes (RygelMPRISMediaPlayerProxy* self)
{
	gchar** result;
	gint result_length1 = 0;
	GVariant* _reply;
	gchar** _tmp6_;
	GVariantBuilder _tmp7_;
	gint _tmp8_;
	result = rygel_mpris_media_player_proxy_get_supported_uri_schemes (self, &result_length1);
	_tmp6_ = result;
	g_variant_builder_init (&_tmp7_, G_VARIANT_TYPE ("as"));
	for (_tmp8_ = 0; _tmp8_ < result_length1; _tmp8_++) {
		g_variant_builder_add_value (&_tmp7_, g_variant_new_string (*_tmp6_));
		_tmp6_++;
	}
	_reply = g_variant_builder_end (&_tmp7_);
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	return _reply;
}

static GVariant*
_dbus_rygel_mpris_media_player_proxy_get_supported_mime_types (RygelMPRISMediaPlayerProxy* self)
{
	gchar** result;
	gint result_length1 = 0;
	GVariant* _reply;
	gchar** _tmp9_;
	GVariantBuilder _tmp10_;
	gint _tmp11_;
	result = rygel_mpris_media_player_proxy_get_supported_mime_types (self, &result_length1);
	_tmp9_ = result;
	g_variant_builder_init (&_tmp10_, G_VARIANT_TYPE ("as"));
	for (_tmp11_ = 0; _tmp11_ < result_length1; _tmp11_++) {
		g_variant_builder_add_value (&_tmp10_, g_variant_new_string (*_tmp9_));
		_tmp9_++;
	}
	_reply = g_variant_builder_end (&_tmp10_);
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	return _reply;
}

static GVariant*
rygel_mpris_media_player_proxy_dbus_interface_get_property (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* property_name,
                                                            GError** error,
                                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Identity") == 0) {
		return _dbus_rygel_mpris_media_player_proxy_get_identity (object);
	} else if (strcmp (property_name, "SupportedUriSchemes") == 0) {
		return _dbus_rygel_mpris_media_player_proxy_get_supported_uri_schemes (object);
	} else if (strcmp (property_name, "SupportedMimeTypes") == 0) {
		return _dbus_rygel_mpris_media_player_proxy_get_supported_mime_types (object);
	}
	return NULL;
}

static gboolean
rygel_mpris_media_player_proxy_dbus_interface_set_property (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* property_name,
                                                            GVariant* value,
                                                            GError** error,
                                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
rygel_mpris_media_player_proxy_register_object (gpointer object,
                                                GDBusConnection* connection,
                                                const gchar* path,
                                                GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_rygel_mpris_media_player_proxy_dbus_interface_info), &_rygel_mpris_media_player_proxy_dbus_interface_vtable, data, _rygel_mpris_media_player_proxy_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_rygel_mpris_media_player_proxy_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

void
rygel_mpris_media_player_player_proxy_pause (RygelMPRISMediaPlayerPlayerProxy* self,
                                             GError** error)
{
	g_return_if_fail (self != NULL);
	RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->pause (self, error);
}

void
rygel_mpris_media_player_player_proxy_play_pause (RygelMPRISMediaPlayerPlayerProxy* self,
                                                  GError** error)
{
	g_return_if_fail (self != NULL);
	RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->play_pause (self, error);
}

void
rygel_mpris_media_player_player_proxy_stop (RygelMPRISMediaPlayerPlayerProxy* self,
                                            GError** error)
{
	g_return_if_fail (self != NULL);
	RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->stop (self, error);
}

void
rygel_mpris_media_player_player_proxy_play (RygelMPRISMediaPlayerPlayerProxy* self,
                                            GError** error)
{
	g_return_if_fail (self != NULL);
	RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->play (self, error);
}

void
rygel_mpris_media_player_player_proxy_seek (RygelMPRISMediaPlayerPlayerProxy* self,
                                            gint64 offset,
                                            GError** error)
{
	g_return_if_fail (self != NULL);
	RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->seek (self, offset, error);
}

void
rygel_mpris_media_player_player_proxy_open_uri (RygelMPRISMediaPlayerPlayerProxy* self,
                                                const gchar* uri,
                                                GError** error)
{
	g_return_if_fail (self != NULL);
	RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->open_uri (self, uri, error);
}

gchar*
rygel_mpris_media_player_player_proxy_get_playback_status (RygelMPRISMediaPlayerPlayerProxy* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->get_playback_status (self);
}

gdouble
rygel_mpris_media_player_player_proxy_get_rate (RygelMPRISMediaPlayerPlayerProxy* self)
{
	g_return_val_if_fail (self != NULL, 0.0);
	return RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->get_rate (self);
}

void
rygel_mpris_media_player_player_proxy_set_rate (RygelMPRISMediaPlayerPlayerProxy* self,
                                                gdouble value)
{
	g_return_if_fail (self != NULL);
	RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->set_rate (self, value);
}

gdouble
rygel_mpris_media_player_player_proxy_get_minimum_rate (RygelMPRISMediaPlayerPlayerProxy* self)
{
	g_return_val_if_fail (self != NULL, 0.0);
	return RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->get_minimum_rate (self);
}

gdouble
rygel_mpris_media_player_player_proxy_get_maximum_rate (RygelMPRISMediaPlayerPlayerProxy* self)
{
	g_return_val_if_fail (self != NULL, 0.0);
	return RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->get_maximum_rate (self);
}

gdouble
rygel_mpris_media_player_player_proxy_get_volume (RygelMPRISMediaPlayerPlayerProxy* self)
{
	g_return_val_if_fail (self != NULL, 0.0);
	return RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->get_volume (self);
}

void
rygel_mpris_media_player_player_proxy_set_volume (RygelMPRISMediaPlayerPlayerProxy* self,
                                                  gdouble value)
{
	g_return_if_fail (self != NULL);
	RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->set_volume (self, value);
}

gint64
rygel_mpris_media_player_player_proxy_get_position (RygelMPRISMediaPlayerPlayerProxy* self)
{
	g_return_val_if_fail (self != NULL, 0LL);
	return RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->get_position (self);
}

gboolean
rygel_mpris_media_player_player_proxy_get_can_seek (RygelMPRISMediaPlayerPlayerProxy* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->get_can_seek (self);
}

gboolean
rygel_mpris_media_player_player_proxy_get_can_control (RygelMPRISMediaPlayerPlayerProxy* self)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->get_can_control (self);
}

GHashTable*
rygel_mpris_media_player_player_proxy_get_metadata (RygelMPRISMediaPlayerPlayerProxy* self)
{
	g_return_val_if_fail (self != NULL, NULL);
	return RYGEL_MPRIS_MEDIA_PLAYER_PLAYER_PROXY_GET_INTERFACE (self)->get_metadata (self);
}

static void
rygel_mpris_media_player_player_proxy_default_init (RygelMPRISMediaPlayerPlayerProxyIface * iface,
                                                    gpointer iface_data)
{
}

GType
rygel_mpris_media_player_player_proxy_get_type (void)
{
	static volatile gsize rygel_mpris_media_player_player_proxy_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_mpris_media_player_player_proxy_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelMPRISMediaPlayerPlayerProxyIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_mpris_media_player_player_proxy_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType rygel_mpris_media_player_player_proxy_type_id;
		rygel_mpris_media_player_player_proxy_type_id = g_type_register_static (G_TYPE_INTERFACE, "RygelMPRISMediaPlayerPlayerProxy", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (rygel_mpris_media_player_player_proxy_type_id, g_dbus_proxy_get_type ());
		g_type_interface_add_prerequisite (rygel_mpris_media_player_player_proxy_type_id, RYGEL_MPRIS_TYPE_MEDIA_PLAYER_PROXY);
		g_type_set_qdata (rygel_mpris_media_player_player_proxy_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) rygel_mpris_media_player_player_proxy_proxy_get_type);
		g_type_set_qdata (rygel_mpris_media_player_player_proxy_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.mpris.MediaPlayer2.Player");
		g_type_set_qdata (rygel_mpris_media_player_player_proxy_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_rygel_mpris_media_player_player_proxy_dbus_interface_info));
		g_type_set_qdata (rygel_mpris_media_player_player_proxy_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) rygel_mpris_media_player_player_proxy_register_object);
		g_once_init_leave (&rygel_mpris_media_player_player_proxy_type_id__volatile, rygel_mpris_media_player_player_proxy_type_id);
	}
	return rygel_mpris_media_player_player_proxy_type_id__volatile;
}

G_DEFINE_TYPE_EXTENDED (RygelMPRISMediaPlayerPlayerProxyProxy, rygel_mpris_media_player_player_proxy_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (RYGEL_MPRIS_TYPE_MEDIA_PLAYER_PROXY, rygel_mpris_media_player_player_proxy_proxy_rygel_mpris_media_player_proxy_interface_init) G_IMPLEMENT_INTERFACE (RYGEL_MPRIS_MEDIA_PLAYER_TYPE_PLAYER_PROXY, rygel_mpris_media_player_player_proxy_proxy_rygel_mpris_media_player_player_proxy_interface_init) )
static void
rygel_mpris_media_player_player_proxy_proxy_class_init (RygelMPRISMediaPlayerPlayerProxyProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = rygel_mpris_media_player_player_proxy_proxy_g_signal;
}

static void
rygel_mpris_media_player_player_proxy_proxy_g_signal (GDBusProxy* proxy,
                                                      const gchar* sender_name,
                                                      const gchar* signal_name,
                                                      GVariant* parameters)
{
}

static void
rygel_mpris_media_player_player_proxy_proxy_init (RygelMPRISMediaPlayerPlayerProxyProxy* self)
{
}

static gchar*
rygel_mpris_media_player_player_proxy_dbus_proxy_get_identity (RygelMPRISMediaPlayerProxy* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Identity");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Identity"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}

static gchar**
rygel_mpris_media_player_player_proxy_dbus_proxy_get_supported_uri_schemes (RygelMPRISMediaPlayerProxy* self,
                                                                            gint* result_length1)
{
	GVariant *_inner_reply;
	gchar** _result;
	gint _result_length1;
	gchar** _tmp12_;
	gint _tmp12__length;
	gint _tmp12__size;
	gint _tmp12__length1;
	GVariantIter _tmp13_;
	GVariant* _tmp14_;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "SupportedUriSchemes");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("SupportedUriSchemes"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result_length1 = 0;
	_tmp12_ = g_new (gchar*, 5);
	_tmp12__length = 0;
	_tmp12__size = 4;
	_tmp12__length1 = 0;
	g_variant_iter_init (&_tmp13_, _inner_reply);
	for (; (_tmp14_ = g_variant_iter_next_value (&_tmp13_)) != NULL; _tmp12__length1++) {
		if (_tmp12__size == _tmp12__length) {
			_tmp12__size = 2 * _tmp12__size;
			_tmp12_ = g_renew (gchar*, _tmp12_, _tmp12__size + 1);
		}
		_tmp12_[_tmp12__length++] = g_variant_dup_string (_tmp14_, NULL);
		g_variant_unref (_tmp14_);
	}
	_result_length1 = _tmp12__length1;
	_tmp12_[_tmp12__length] = NULL;
	_result = _tmp12_;
	*result_length1 = _result_length1;
	g_variant_unref (_inner_reply);
	return _result;
}

static gchar**
rygel_mpris_media_player_player_proxy_dbus_proxy_get_supported_mime_types (RygelMPRISMediaPlayerProxy* self,
                                                                           gint* result_length1)
{
	GVariant *_inner_reply;
	gchar** _result;
	gint _result_length1;
	gchar** _tmp15_;
	gint _tmp15__length;
	gint _tmp15__size;
	gint _tmp15__length1;
	GVariantIter _tmp16_;
	GVariant* _tmp17_;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "SupportedMimeTypes");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("SupportedMimeTypes"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result_length1 = 0;
	_tmp15_ = g_new (gchar*, 5);
	_tmp15__length = 0;
	_tmp15__size = 4;
	_tmp15__length1 = 0;
	g_variant_iter_init (&_tmp16_, _inner_reply);
	for (; (_tmp17_ = g_variant_iter_next_value (&_tmp16_)) != NULL; _tmp15__length1++) {
		if (_tmp15__size == _tmp15__length) {
			_tmp15__size = 2 * _tmp15__size;
			_tmp15_ = g_renew (gchar*, _tmp15_, _tmp15__size + 1);
		}
		_tmp15_[_tmp15__length++] = g_variant_dup_string (_tmp17_, NULL);
		g_variant_unref (_tmp17_);
	}
	_result_length1 = _tmp15__length1;
	_tmp15_[_tmp15__length] = NULL;
	_result = _tmp15_;
	*result_length1 = _result_length1;
	g_variant_unref (_inner_reply);
	return _result;
}

static void
rygel_mpris_media_player_player_proxy_proxy_rygel_mpris_media_player_proxy_interface_init (RygelMPRISMediaPlayerProxyIface* iface)
{
	iface->get_identity = rygel_mpris_media_player_player_proxy_dbus_proxy_get_identity;
	iface->get_supported_uri_schemes = rygel_mpris_media_player_player_proxy_dbus_proxy_get_supported_uri_schemes;
	iface->get_supported_mime_types = rygel_mpris_media_player_player_proxy_dbus_proxy_get_supported_mime_types;
}

static void
rygel_mpris_media_player_player_proxy_proxy_pause (RygelMPRISMediaPlayerPlayerProxy* self,
                                                   GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2.Player", "Pause");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
rygel_mpris_media_player_player_proxy_proxy_play_pause (RygelMPRISMediaPlayerPlayerProxy* self,
                                                        GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2.Player", "PlayPause");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
rygel_mpris_media_player_player_proxy_proxy_stop (RygelMPRISMediaPlayerPlayerProxy* self,
                                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2.Player", "Stop");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
rygel_mpris_media_player_player_proxy_proxy_play (RygelMPRISMediaPlayerPlayerProxy* self,
                                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2.Player", "Play");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
rygel_mpris_media_player_player_proxy_proxy_seek (RygelMPRISMediaPlayerPlayerProxy* self,
                                                  gint64 offset,
                                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2.Player", "Seek");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int64 (offset));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
rygel_mpris_media_player_player_proxy_proxy_open_uri (RygelMPRISMediaPlayerPlayerProxy* self,
                                                      const gchar* uri,
                                                      GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	G_DBUS_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.mpris.MediaPlayer2.Player", "OpenUri");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (uri));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static gchar*
rygel_mpris_media_player_player_proxy_dbus_proxy_get_playback_status (RygelMPRISMediaPlayerPlayerProxy* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "PlaybackStatus");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("PlaybackStatus"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
rygel_mpris_media_player_player_proxy_dbus_proxy_get_rate (RygelMPRISMediaPlayerPlayerProxy* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Rate");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Rate"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp18_ = 0.0;
			return _tmp18_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
rygel_mpris_media_player_player_proxy_dbus_proxy_set_rate (RygelMPRISMediaPlayerPlayerProxy* self,
                                                           gdouble value)
{
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Rate"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_double (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}

static gdouble
rygel_mpris_media_player_player_proxy_dbus_proxy_get_minimum_rate (RygelMPRISMediaPlayerPlayerProxy* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "MinimumRate");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("MinimumRate"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp19_ = 0.0;
			return _tmp19_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
rygel_mpris_media_player_player_proxy_dbus_proxy_get_maximum_rate (RygelMPRISMediaPlayerPlayerProxy* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "MaximumRate");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("MaximumRate"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp20_ = 0.0;
			return _tmp20_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gdouble
rygel_mpris_media_player_player_proxy_dbus_proxy_get_volume (RygelMPRISMediaPlayerPlayerProxy* self)
{
	GVariant *_inner_reply;
	gdouble _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Volume");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Volume"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gdouble _tmp21_ = 0.0;
			return _tmp21_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_double (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
rygel_mpris_media_player_player_proxy_dbus_proxy_set_volume (RygelMPRISMediaPlayerPlayerProxy* self,
                                                             gdouble value)
{
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Volume"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_double (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}

static gint64
rygel_mpris_media_player_player_proxy_dbus_proxy_get_position (RygelMPRISMediaPlayerPlayerProxy* self)
{
	GVariant *_inner_reply;
	gint64 _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Position");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Position"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gint64 _tmp22_ = 0LL;
			return _tmp22_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_int64 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
rygel_mpris_media_player_player_proxy_dbus_proxy_get_can_seek (RygelMPRISMediaPlayerPlayerProxy* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "CanSeek");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("CanSeek"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp23_ = FALSE;
			return _tmp23_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static gboolean
rygel_mpris_media_player_player_proxy_dbus_proxy_get_can_control (RygelMPRISMediaPlayerPlayerProxy* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "CanControl");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("CanControl"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp24_ = FALSE;
			return _tmp24_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static GHashTable*
rygel_mpris_media_player_player_proxy_dbus_proxy_get_metadata (RygelMPRISMediaPlayerPlayerProxy* self)
{
	GVariant *_inner_reply;
	GHashTable* _result;
	GHashTable* _tmp25_;
	GVariantIter _tmp26_;
	GVariant* _tmp27_;
	GVariant* _tmp28_;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Metadata");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.mpris.MediaPlayer2.Player"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Metadata"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_tmp25_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp26_, _inner_reply);
	while (g_variant_iter_loop (&_tmp26_, "{?*}", &_tmp27_, &_tmp28_)) {
		g_hash_table_insert (_tmp25_, g_variant_dup_string (_tmp27_, NULL), g_variant_get_variant (_tmp28_));
	}
	_result = _tmp25_;
	g_variant_unref (_inner_reply);
	return _result;
}

static void
rygel_mpris_media_player_player_proxy_proxy_rygel_mpris_media_player_player_proxy_interface_init (RygelMPRISMediaPlayerPlayerProxyIface* iface)
{
	iface->pause = rygel_mpris_media_player_player_proxy_proxy_pause;
	iface->play_pause = rygel_mpris_media_player_player_proxy_proxy_play_pause;
	iface->stop = rygel_mpris_media_player_player_proxy_proxy_stop;
	iface->play = rygel_mpris_media_player_player_proxy_proxy_play;
	iface->seek = rygel_mpris_media_player_player_proxy_proxy_seek;
	iface->open_uri = rygel_mpris_media_player_player_proxy_proxy_open_uri;
	iface->get_playback_status = rygel_mpris_media_player_player_proxy_dbus_proxy_get_playback_status;
	iface->get_rate = rygel_mpris_media_player_player_proxy_dbus_proxy_get_rate;
	iface->set_rate = rygel_mpris_media_player_player_proxy_dbus_proxy_set_rate;
	iface->get_minimum_rate = rygel_mpris_media_player_player_proxy_dbus_proxy_get_minimum_rate;
	iface->get_maximum_rate = rygel_mpris_media_player_player_proxy_dbus_proxy_get_maximum_rate;
	iface->get_volume = rygel_mpris_media_player_player_proxy_dbus_proxy_get_volume;
	iface->set_volume = rygel_mpris_media_player_player_proxy_dbus_proxy_set_volume;
	iface->get_position = rygel_mpris_media_player_player_proxy_dbus_proxy_get_position;
	iface->get_can_seek = rygel_mpris_media_player_player_proxy_dbus_proxy_get_can_seek;
	iface->get_can_control = rygel_mpris_media_player_player_proxy_dbus_proxy_get_can_control;
	iface->get_metadata = rygel_mpris_media_player_player_proxy_dbus_proxy_get_metadata;
}

static void
_dbus_rygel_mpris_media_player_player_proxy_pause (RygelMPRISMediaPlayerPlayerProxy* self,
                                                   GVariant* _parameters_,
                                                   GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	rygel_mpris_media_player_player_proxy_pause (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_rygel_mpris_media_player_player_proxy_play_pause (RygelMPRISMediaPlayerPlayerProxy* self,
                                                        GVariant* _parameters_,
                                                        GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	rygel_mpris_media_player_player_proxy_play_pause (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_rygel_mpris_media_player_player_proxy_stop (RygelMPRISMediaPlayerPlayerProxy* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	rygel_mpris_media_player_player_proxy_stop (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_rygel_mpris_media_player_player_proxy_play (RygelMPRISMediaPlayerPlayerProxy* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	rygel_mpris_media_player_player_proxy_play (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_rygel_mpris_media_player_player_proxy_seek (RygelMPRISMediaPlayerPlayerProxy* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gint64 offset = 0LL;
	GVariant* _tmp29_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp29_ = g_variant_iter_next_value (&_arguments_iter);
	offset = g_variant_get_int64 (_tmp29_);
	g_variant_unref (_tmp29_);
	rygel_mpris_media_player_player_proxy_seek (self, offset, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_rygel_mpris_media_player_player_proxy_open_uri (RygelMPRISMediaPlayerPlayerProxy* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* uri = NULL;
	GVariant* _tmp30_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp30_ = g_variant_iter_next_value (&_arguments_iter);
	uri = g_variant_dup_string (_tmp30_, NULL);
	g_variant_unref (_tmp30_);
	rygel_mpris_media_player_player_proxy_open_uri (self, uri, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (uri);
}

static void
rygel_mpris_media_player_player_proxy_dbus_interface_method_call (GDBusConnection* connection,
                                                                  const gchar* sender,
                                                                  const gchar* object_path,
                                                                  const gchar* interface_name,
                                                                  const gchar* method_name,
                                                                  GVariant* parameters,
                                                                  GDBusMethodInvocation* invocation,
                                                                  gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Pause") == 0) {
		_dbus_rygel_mpris_media_player_player_proxy_pause (object, parameters, invocation);
	} else if (strcmp (method_name, "PlayPause") == 0) {
		_dbus_rygel_mpris_media_player_player_proxy_play_pause (object, parameters, invocation);
	} else if (strcmp (method_name, "Stop") == 0) {
		_dbus_rygel_mpris_media_player_player_proxy_stop (object, parameters, invocation);
	} else if (strcmp (method_name, "Play") == 0) {
		_dbus_rygel_mpris_media_player_player_proxy_play (object, parameters, invocation);
	} else if (strcmp (method_name, "Seek") == 0) {
		_dbus_rygel_mpris_media_player_player_proxy_seek (object, parameters, invocation);
	} else if (strcmp (method_name, "OpenUri") == 0) {
		_dbus_rygel_mpris_media_player_player_proxy_open_uri (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_rygel_mpris_media_player_player_proxy_get_playback_status (RygelMPRISMediaPlayerPlayerProxy* self)
{
	gchar* result;
	GVariant* _reply;
	result = rygel_mpris_media_player_player_proxy_get_playback_status (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}

static GVariant*
_dbus_rygel_mpris_media_player_player_proxy_get_rate (RygelMPRISMediaPlayerPlayerProxy* self)
{
	gdouble result;
	GVariant* _reply;
	result = rygel_mpris_media_player_player_proxy_get_rate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_rygel_mpris_media_player_player_proxy_get_minimum_rate (RygelMPRISMediaPlayerPlayerProxy* self)
{
	gdouble result;
	GVariant* _reply;
	result = rygel_mpris_media_player_player_proxy_get_minimum_rate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_rygel_mpris_media_player_player_proxy_get_maximum_rate (RygelMPRISMediaPlayerPlayerProxy* self)
{
	gdouble result;
	GVariant* _reply;
	result = rygel_mpris_media_player_player_proxy_get_maximum_rate (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_rygel_mpris_media_player_player_proxy_get_volume (RygelMPRISMediaPlayerPlayerProxy* self)
{
	gdouble result;
	GVariant* _reply;
	result = rygel_mpris_media_player_player_proxy_get_volume (self);
	_reply = g_variant_new_double (result);
	return _reply;
}

static GVariant*
_dbus_rygel_mpris_media_player_player_proxy_get_position (RygelMPRISMediaPlayerPlayerProxy* self)
{
	gint64 result;
	GVariant* _reply;
	result = rygel_mpris_media_player_player_proxy_get_position (self);
	_reply = g_variant_new_int64 (result);
	return _reply;
}

static GVariant*
_dbus_rygel_mpris_media_player_player_proxy_get_can_seek (RygelMPRISMediaPlayerPlayerProxy* self)
{
	gboolean result;
	GVariant* _reply;
	result = rygel_mpris_media_player_player_proxy_get_can_seek (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_rygel_mpris_media_player_player_proxy_get_can_control (RygelMPRISMediaPlayerPlayerProxy* self)
{
	gboolean result;
	GVariant* _reply;
	result = rygel_mpris_media_player_player_proxy_get_can_control (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_rygel_mpris_media_player_player_proxy_get_metadata (RygelMPRISMediaPlayerPlayerProxy* self)
{
	GHashTable* result;
	GVariant* _reply;
	GVariantBuilder _tmp31_;
	GHashTableIter _tmp32_;
	gpointer _tmp33_;
	gpointer _tmp34_;
	result = rygel_mpris_media_player_player_proxy_get_metadata (self);
	g_hash_table_iter_init (&_tmp32_, result);
	g_variant_builder_init (&_tmp31_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp32_, &_tmp33_, &_tmp34_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp33_;
		_value = (GVariant*) _tmp34_;
		g_variant_builder_add (&_tmp31_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	_reply = g_variant_builder_end (&_tmp31_);
	_g_hash_table_unref0 (result);
	return _reply;
}

static GVariant*
rygel_mpris_media_player_player_proxy_dbus_interface_get_property (GDBusConnection* connection,
                                                                   const gchar* sender,
                                                                   const gchar* object_path,
                                                                   const gchar* interface_name,
                                                                   const gchar* property_name,
                                                                   GError** error,
                                                                   gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PlaybackStatus") == 0) {
		return _dbus_rygel_mpris_media_player_player_proxy_get_playback_status (object);
	} else if (strcmp (property_name, "Rate") == 0) {
		return _dbus_rygel_mpris_media_player_player_proxy_get_rate (object);
	} else if (strcmp (property_name, "MinimumRate") == 0) {
		return _dbus_rygel_mpris_media_player_player_proxy_get_minimum_rate (object);
	} else if (strcmp (property_name, "MaximumRate") == 0) {
		return _dbus_rygel_mpris_media_player_player_proxy_get_maximum_rate (object);
	} else if (strcmp (property_name, "Volume") == 0) {
		return _dbus_rygel_mpris_media_player_player_proxy_get_volume (object);
	} else if (strcmp (property_name, "Position") == 0) {
		return _dbus_rygel_mpris_media_player_player_proxy_get_position (object);
	} else if (strcmp (property_name, "CanSeek") == 0) {
		return _dbus_rygel_mpris_media_player_player_proxy_get_can_seek (object);
	} else if (strcmp (property_name, "CanControl") == 0) {
		return _dbus_rygel_mpris_media_player_player_proxy_get_can_control (object);
	} else if (strcmp (property_name, "Metadata") == 0) {
		return _dbus_rygel_mpris_media_player_player_proxy_get_metadata (object);
	}
	return NULL;
}

static void
_dbus_rygel_mpris_media_player_player_proxy_set_rate (RygelMPRISMediaPlayerPlayerProxy* self,
                                                      GVariant* _value)
{
	gdouble value = 0.0;
	value = g_variant_get_double (_value);
	rygel_mpris_media_player_player_proxy_set_rate (self, value);
}

static void
_dbus_rygel_mpris_media_player_player_proxy_set_volume (RygelMPRISMediaPlayerPlayerProxy* self,
                                                        GVariant* _value)
{
	gdouble value = 0.0;
	value = g_variant_get_double (_value);
	rygel_mpris_media_player_player_proxy_set_volume (self, value);
}

static gboolean
rygel_mpris_media_player_player_proxy_dbus_interface_set_property (GDBusConnection* connection,
                                                                   const gchar* sender,
                                                                   const gchar* object_path,
                                                                   const gchar* interface_name,
                                                                   const gchar* property_name,
                                                                   GVariant* value,
                                                                   GError** error,
                                                                   gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Rate") == 0) {
		_dbus_rygel_mpris_media_player_player_proxy_set_rate (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Volume") == 0) {
		_dbus_rygel_mpris_media_player_player_proxy_set_volume (object, value);
		return TRUE;
	}
	return FALSE;
}

guint
rygel_mpris_media_player_player_proxy_register_object (gpointer object,
                                                       GDBusConnection* connection,
                                                       const gchar* path,
                                                       GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_rygel_mpris_media_player_player_proxy_dbus_interface_info), &_rygel_mpris_media_player_player_proxy_dbus_interface_vtable, data, _rygel_mpris_media_player_player_proxy_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_rygel_mpris_media_player_player_proxy_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

